<template>
	<form @submit="add" class="mx-auto max-w-max mt-15">
		<p class="text-center font-bold mb-6">To Do / Work Done</p>
		<div>
			<label class="inline-block w-24" for="checklist-input"
				>Checklist</label
			>
			<input
				type="text"
				required
				name="checklist"
				id="checklist-input"
				v-model="checklist"
				class="border-b border-gray-400 w-48 my-1 px-2"
			/>
		</div>

		<div>
			<label class="inline-block w-24" for="date-input">Time</label>
			<input
				type="date"
				name="date"
				id="date-input"
				v-model="date"
				class="border-b border-gray-400 w-48 my-1 px-2"
			/>
		</div>

		<div class="text-right mt-2">
			<input type="checkbox" v-model="done" />
			<label class="inline-block ml-2">Done</label>
		</div>

		<div class="text-right mt-2">
			<input
				class="
					rounded-lg
					py-1
					px-6
					ml-4
					bg-blue-200
					hover:bg-blue-400
					active:bg-blue-400
				"
				type="submit"
				value="Add"
			/>
		</div>
		<p>{{ error }}</p>
	</form>
</template>

<script>
import { ref } from "@vue/runtime-core";
import { useStore } from "vuex";
import { ADDING_CHECKLIST } from "../../store/actions";

export default {
	name: "ChecklistForm",
	setup() {
		const store = useStore();

		const checklist = ref("");
		const date = ref(new Date().toISOString().slice(0, 10));
		const done = ref(false);
		const error = ref(null);
		const userId = store.state.user.uid;

		const add = (e) => {
			e.preventDefault();
			if (
				checklist.value === "" ||
				!/[0-9]{4}-[0-9]{2}-[0-9]{2}/.test(date.value)
			) {
				// console.log("error");
				error.value =
					"Checklist mustn't empty and/or date format are wrong";
			} else {
				store.dispatch({
					type: ADDING_CHECKLIST,
					payload: {
						checklist: {
							checklist: checklist.value,
							date: date.value,
							done: done.value,
							id: new Date().getTime(),
						},
						userId
					},
				}).then(() => {})
				.catch(() => {});
				error.value = null;
				checklist.value = "";
			}
		};
		return { add, checklist, date, done, error };
	},
};
</script>

<style></style>
